const { dialogflow, SimpleResponse,BasicCard, Carousel, BrowseCarousel,
        BrowseCarouselItem, Image, Item, List } = require('actions-on-google');
const request = require('sync-request');

const BASE_URL = 'https://api.colorado.ifro.edu.br/academico';
const AUTHORIZATION_KEY = 'key=Bi479DxWjsNFFcZOVyySbx2vZ7rhhdU4Gr8OeJ0W1qvE7hGHxsQlwhbUZVRttmsQ';


function findCurso(nomeCurso) {

    //Selecionando o curso
    var req = request('GET', `${BASE_URL}/unidade/4/cursos`, {
        headers: {
            Authorization: AUTHORIZATION_KEY
        }
    });
    
    const cursos = JSON.parse(req.getBody('utf8')).cursos;
    let curso = cursos.filter(c => c.nome.toLowerCase().includes(nomeCurso));

    return curso[0];

}

function findTurma(curso, ano, turma) {

    //Selecionando a turma
    req = request('GET', `${BASE_URL}/curso/${curso.cursoId}/turmas/abertas`, {
        headers: {
            Authorization: AUTHORIZATION_KEY
        }
    });

    let turmas = JSON.parse(req.getBody('utf8')).turmas;
    console.log(`Turmas` +  JSON.stringify(turmas));
    turmas = turmas.filter(t => 
        t.identificador.includes(ano + turma.toUpperCase()));

    return turmas[0];

}

function findHorario(turma) {

    //Buscando os horários
    req = request('GET', `${BASE_URL}/turma/${turma.turmaId}/horarios`, {
        headers: {
            Authorization: AUTHORIZATION_KEY
        }
    });
    
    const horarios = JSON.parse(req.getBody('utf8')).horarios;
    return horarios[0];
}

exports.action = (conv) => {

    let params = conv.parameters;

    const curso = findCurso(params.curso);
    const turma = findTurma(curso, params.ano, params.turma);
    const horario = findHorario(turma);
    
    //Gerando mensagens
    let text = `Dia **${horario.dataHorario}**, *${horario.diaSemana}*:  \n`;
    let speech = "Encontrei essas aulas: ";
    horario.aulas.forEach(a => {
        var naula = a.nomeClasse.substring(a.nomeClasse.indexOf("-") +1, a.nomeClasse.length );
        text = text.concat(`__${naula}__, às *${a.horarioInicio}*;  \n`);
        speech = speech.concat(`às ${a.horarioInicio}, aula de ${naula}. `);
    });


    // Envio um texto falado
    conv.ask(new SimpleResponse({
        speech: speech,
        text: 'aqui está:'
    }));

    //Se houver suporte para tela, envio um BasicCard para visualização
    if (conv.surface.capabilities.has('actions.capability.SCREEN_OUTPUT')) {
        
        conv.ask(new BasicCard({
            text: text,
            subtitle: `${curso.nome}`,
            title: `HORÁRIO do dia ${horario.dataHorario} `,
            display: 'CROPPED',
        }));
    }
}